## scalapack 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(SCALAPACK C Fortran)
# Configure the warning and code coverage suppression file
configure_file( 
  "${SCALAPACK_SOURCE_DIR}/CMAKE/CTestCustom.cmake.in"
  "${SCALAPACK_BINARY_DIR}/CTestCustom.cmake"
  COPYONLY
)

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${SCALAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "ifort" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

#
#   MPI
#
#set(MPI_BASE_DIR "/Users/julie/opt/openmpi/" CACHE PATH "MPI Path")
#set(MPI_BASE_DIR "/Users/julie/opt/mpich2/" CACHE PATH "MPI Path")
set(CMAKE_PREFIX_PATH "${MPI_BASE_DIR};${CMAKE_PREFIX_PATH}")
#set(MPI_COMPILER ${MPI_BASE_DIR}/bin/mpicc)

find_package(MPI)
if (MPI_FOUND)
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})

   find_program(MPI_C_COMPILER
      NAMES mpicc
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI C compiler.")
   MARK_AS_ADVANCED(MPI_C_COMPILER)
   if ("${MPI_C_COMPILER}" STREQUAL "MPI_C_COMPILER-NOTFOUND")
      message(ERROR "--> MPI C Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI C Compiler : ${MPI_C_COMPILER}")
      SET(CMAKE_C_COMPILER "${MPI_C_COMPILER}")
      message(STATUS "--> C Compiler : ${CMAKE_C_COMPILER}")
   endif()
   find_program(MPI_Fortran_COMPILER
      NAMES mpif77
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI Fortran compiler.")
   MARK_AS_ADVANCED(MPI_Fortran_COMPILER)
   
   

   if ("${MPI_Fortran_COMPILER}" STREQUAL "MPI_Fortran_COMPILER-NOTFOUND")
      message(ERROR "--> MPI Fortran Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI Fortran Compiler : ${MPI_Fortran_COMPILER}")
      SET(Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")
      SET(CMAKE_Fortran_COMPILER "${MPI_Fortran_COMPILER}")
      message(STATUS "--> Fortran Compiler : ${CMAKE_Fortran_COMPILER}")
   endif()
   
else()
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   set(MPI_BASE_DIR ${MPI_BASE_DIR} CACHE PATH "MPI Path")
   UNSET(MPIEXEC CACHE)
   UNSET(MPIEXEC_POSTFLAGS CACHE)
   UNSET(MPIEXEC_PREFLAGS CACHE)
   UNSET(MPIEXEC_MAX_NUMPROCS CACHE)
   UNSET(MPIEXEC_NUMPROC_FLAG CACHE)
   UNSET(MPI_COMPILE_FLAGS CACHE)
   UNSET(MPI_LINK_FLAGS CACHE)
   UNSET(MPI_INCLUDE_PATH CACHE)
   message(FATAL_ERROR "--> MPI Library NOT FOUND -- please set MPI_BASE_DIR accordingly --")
endif()


if (UNIX)
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "ifort" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

macro(SCALAPACK_install_library lib)
  install(TARGETS ${lib} EXPORT scalapack-targets
    ARCHIVE DESTINATION lib${LIB_SUFFIX}
    LIBRARY DESTINATION lib${LIB_SUFFIX}
    RUNTIME DESTINATION Testing
  )
endmacro()

# --------------------------------------------------
# Testing
SET(DART_TESTING_TIMEOUT 600)

enable_testing()
include(CTest)
enable_testing()
# --------------------------------------------------

# Organize output files.  On Windows this also keeps .dll files next
# to the .exe files that need them, making tests easy to run.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckBLACSCompilerFlags )
CheckBLACSCompilerFlags()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(PKG_CONFIG_DIR ${libdir}/pkgconfig)

# --------------------------------------------------
# BLACS Internal variables
#
#   Fortran Mangling, MPI Tests and BLACS settings
#
include(FortranMangling)
COMPILE(install_COMPILED)

FORTRAN_MANGLING(CDEFS)
#MESSAGE(STATUS "Setting CDEFS = ${CDEFS}")
#set(CDEFS ${CDEFS} CACHE STRING "Fortran Mangling" FORCE)
MESSAGE(STATUS "=========")

# --------------------------------------------------
# Compiler Flags
ADD_DEFINITIONS( "-D${CDEFS}")

# --------------------------------------------------
# ScaLAPACK needs BLAS and LAPACK

option(USE_OPTIMIZED_LAPACK_BLAS "Whether or not to search for optimized LAPACK and BLAS libraries on your machine (if not found, Reference LAPACK and BLAS will be downloaded and installed)" ON)

message(STATUS "CHECKING BLAS AND LAPACK LIBRARIES")

IF(LAPACK_LIBRARIES)
  include(CheckFortranFunctionExists)
  message(STATUS "--> LAPACK supplied by user is ${LAPACK_LIBRARIES}.")
  set(CMAKE_REQUIRED_LIBRARIES ${LAPACK_LIBRARIES})
  CHECK_FORTRAN_FUNCTION_EXISTS("dgesv" LAPACK_FOUND)
  unset( CMAKE_REQUIRED_LIBRARIES )
  message(STATUS "--> LAPACK routine dgesv is found: ${LAPACK_FOUND}.")
ENDIF()

if(LAPACK_FOUND)
      message(STATUS "--> LAPACK supplied by user is WORKING, will use ${LAPACK_LIBRARIES}.")
else(LAPACK_FOUND)
   if(USE_OPTIMIZED_LAPACK_BLAS)
      message(STATUS "--> Searching for optimized LAPACK and BLAS libraries on your machine.")
      find_package(LAPACK)
   ENDIF(USE_OPTIMIZED_LAPACK_BLAS)
   if(NOT LAPACK_FOUND)
      message(STATUS "--> LAPACK and BLAS were not found. Reference LAPACK and BLAS will be downloaded and installed")
      include(ExternalProject)
      ExternalProject_Add(
		lapack
		URL http://www.netlib.org/lapack/lapack.tgz
		CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${SCALAPACK_BINARY_DIR}
        PREFIX ${SCALAPACK_BINARY_DIR}/dependencies
      )
	  if (UNIX)
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.a CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.a CACHE STRING "BLAS library" FORCE)
	  else (UNIX) # On Windows
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.lib CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.lib CACHE STRING "BLAS library" FORCE)
      endif (UNIX)
   ENDIF()
ENDIF()

message(STATUS "BLAS library: ${BLAS_LIBRARIES}")
message(STATUS "LAPACK library: ${LAPACK_LIBRARIES}")

MESSAGE(STATUS "=========")

# --------------------------------------------------
# By default static library
OPTION(BUILD_SHARED_LIBS "Build shared libraries" OFF )
OPTION(BUILD_STATIC_LIBS "Build static libraries" ON )

# --------------------------------------------------
# Subdirectories that need to be processed
   
macro(append_subdir_files variable dirname)
get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
foreach(depfile ${holder})
  list(APPEND ${variable} "${dirname}/${depfile}")
endforeach()
endmacro()


#
# BLACS
#
add_subdirectory(BLACS)
append_subdir_files(blacs "BLACS/SRC")

#
# TOOLS
#
add_subdirectory(TOOLS)
append_subdir_files(tools TOOLS)
append_subdir_files(tools-C TOOLS)
append_subdir_files(extra_lapack "TOOLS/LAPACK")

#
# PBLAS
#
add_subdirectory(PBLAS)
append_subdir_files(pblas "PBLAS/SRC")
append_subdir_files(pblas-F "PBLAS/SRC")
append_subdir_files(pbblas "PBLAS/SRC/PBBLAS")
append_subdir_files(ptzblas "PBLAS/SRC/PTZBLAS")
append_subdir_files(ptools "PBLAS/SRC/PTOOLS")

#
# REDIST
#
add_subdirectory(REDIST)
append_subdir_files(redist "REDIST/SRC")

#
# SRC
#
add_subdirectory(SRC)
append_subdir_files(src "SRC")
append_subdir_files(src-C "SRC")

if (UNIX)
   add_library(scalapack ${blacs} ${tools} ${tools-C} ${extra_lapack} ${pblas} ${pblas-F} ${ptzblas} ${ptools} ${pbblas} ${redist} ${src} ${src-C})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   scalapack_install_library(scalapack)
else (UNIX) # Need to separate Fortran and C Code
   OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON )
   add_library(scalapack ${blacs} ${tools-C} ${pblas} ${ptools} ${redist} ${src-C})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   add_library(scalapack-F ${pblas-F} ${pbblas} ${ptzblas} ${tools} ${src} ${extra_lapack} )
   target_link_libraries( scalapack-F ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   scalapack_install_library(scalapack)
   scalapack_install_library(scalapack-F)
endif (UNIX)
add_subdirectory(TESTING)

# --------------------------------------------------
# CPACK Packaging 

SET(CPACK_PACKAGE_NAME "ScaLAPACK")
SET(CPACK_PACKAGE_VENDOR "University of Tennessee, Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ScaLAPACK- Linear Algebra Package")
set(SCALAPACK_VERSION 2.1.0)
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "SCALAPACK")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\http://icl.cs.utk.edu/lapack-forum")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.netlib.org/scalapack")
  SET(CPACK_NSIS_CONTACT "scalapack@eecs.utk.edu")
  SET(CPACK_NSIS_MODIFY_PATH ON)
  SET(CPACK_NSIS_DISPLAY_NAME "SCALAPACK-${SCALAPACK_VERSION}")
  set(CPACK_PACKAGE_RELOCATABLE "true")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_GENERATOR "TGZ")
  SET(CPACK_SOURCE_GENERATOR TGZ)
  SET(CPACK_SOURCE_PACKAGE_FILE_NAME "scalapack-${SCALAPACK_VERSION}" )
  SET(CPACK_SOURCE_IGNORE_FILES ~$ .svn ${CPACK_SOURCE_IGNORE_FILES} )
ENDIF(WIN32 AND NOT UNIX)
INCLUDE(CPack)


# --------------------------------------------------


export(TARGETS scalapack FILE scalapack-targets.cmake)

if( NOT LAPACK_FOUND )
 install(FILES
  ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
  DESTINATION lib
   )
endif( NOT LAPACK_FOUND )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-version.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake @ONLY)
configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-build.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scalapack.pc.in ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc)
 install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc
  DESTINATION ${PKG_CONFIG_DIR}
   )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-install.cmake.in
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake @ONLY)
install(FILES
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION}
  )

install(EXPORT scalapack-targets
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION})

=== BLACS/CMakeLists.txt ===
add_subdirectory(SRC)
if(BUILD_TESTING)
  add_subdirectory(TESTING)
endif(BUILD_TESTING)

=== EXAMPLE/Makefile ===
include ../SLmake.inc

TESTOBJS = psscaex.o pdscaexinfo.o
TESTOBJD = pdscaex.o pdscaexinfo.o
TESTOBJC = pcscaex.o pdscaexinfo.o
TESTOBJZ = pzscaex.o pdscaexinfo.o

all: pdscaex pcscaex pzscaex psscaex

single: psscaex

double: pdscaex

complex: pcscaex

complex16: pzscaex

psscaex: $(TESTOBJS)
	$(FCLOADER) $(FCLOADFLAGS) -o xsscaex $(TESTOBJS) ../$(SCALAPACKLIB) $(LIBS)

pzscaex: $(TESTOBJZ)
	$(FCLOADER) $(FCLOADFLAGS) -o xzscaex $(TESTOBJZ) ../$(SCALAPACKLIB) $(LIBS)

pcscaex: $(TESTOBJC)
	$(FCLOADER) $(FCLOADFLAGS) -o xcscaex $(TESTOBJC) ../$(SCALAPACKLIB) $(LIBS)

pdscaex: $(TESTOBJD)
	$(FCLOADER) $(FCLOADFLAGS) -o xdscaex $(TESTOBJD) ../$(SCALAPACKLIB) $(LIBS)

clean :
	rm -f $(TESTOBJS) $(TESTOBJD) $(TESTOBJZ) $(TESTOBJC) xsscaex xzscaex xcscaex xdscaex

.f.o : ; $(FC) -c $(FCFLAGS) $*.f

.c.o : ; $(CC) -c $(CDEFS) $(CCFLAGS) $*.c

=== PBLAS/CMakeLists.txt ===
add_subdirectory(SRC)
add_subdirectory(TESTING)
add_subdirectory(TIMING)

=== SRC/CMakeLists.txt ===
set (ALLAUX  pjlaenv.f  pilaenvx.f piparmq.f pilaver.f pmpim2.f pmpcol.f)
set (ALLAUX-C  pbchkvect.c getpbbuf.c pcrot.c pslaiect.c pdlaiect.c pzrot.c slamov.c clamov.c dlamov.c zlamov.c)

set (SCLAUX  
   pslabad.f pslaed0.f pslaed1.f pslaed2.f pslaed3.f pslaedz.f 
   pslamch.f pslared1d.f pslasrt.f psstebz.f psstedc.f slapst.f slasrt2.f 
   sstein2.f
   slar1va.f slarrb2.f slarrd2.f slarre2.f slarre2a.f slarrf2.f
   slarrv2.f sstegr2.f sstegr2a.f sstegr2b.f)

set (DZLAUX  
   pdlabad.f pdlaed0.f pdlaed1.f pdlaed2.f pdlaed3.f pdlaedz.f 
   pdlamch.f pdlared1d.f pdlasrt.f pdstebz.f pdstedc.f dlapst.f dlasrt2.f 
   dstein2.f
   dlar1va.f dlarrb2.f dlarrd2.f dlarre2.f dlarre2a.f dlarrf2.f
   dlarrv2.f dstegr2.f dstegr2a.f dstegr2b.f)

set (SLASRC  
   psdbsv.f  psdbtrf.f psdbtrs.f psdbtrsv.f 
   psdtsv.f  psdttrf.f psdttrs.f psdttrsv.f 
   psgbsv.f  psgbtrf.f psgbtrs.f 
   psgebd2.f psgebrd.f psgecon.f pstrcon.f psgeequ.f psgehd2.f psgehrd.f
   psgelq2.f psgelqf.f psgels.f  psgeql2.f psgeqlf.f psgeqpf.f psgeqr2.f 
   psgeqrf.f psgerfs.f psgerq2.f psgerqf.f                               
   psgesv.f  psgesvd.f psgesvx.f psgetf2.f psgetrf.f psgetri.f psgetrs.f 
   psggqrf.f psggrqf.f pslabrd.f 
   pslacon.f pslacp2.f pslacpy.f pslahrd.f pslange.f pslanhs.f pslansy.f 
   pslantr.f pslapiv.f pslapv2.f pslaqge.f pslaqsy.f pslarf.f  pslarfb.f 
   pslarfg.f pslarft.f pslase2.f pslaset.f pslascl.f pslassq.f pslaswp.f 
   pslatra.f pslatrd.f pslatrs.f pslauu2.f pslauum.f psorg2l.f psorg2r.f 
                       psorgl2.f psorglq.f psorgql.f psorgqr.f psorgr2.f 
   psorgrq.f           psorm2l.f psorm2r.f psormbr.f psormhr.f psorml2.f 
   psormlq.f psormql.f psormqr.f psormr2.f psormrq.f psormtr.f pspocon.f 
   pspbsv.f  pspbtrf.f pspbtrs.f pspbtrsv.f 
   psptsv.f  pspttrf.f pspttrs.f pspttrsv.f 
   pspoequ.f psporfs.f psposv.f  psposvx.f pspotf2.f pspotrf.f pspotri.f 
   pspotrs.f psrscl.f  psstein.f pssyev.f  pssyevd.f pssyevx.f 
   pssygs2.f pssygst.f 
   pssygvx.f pssyngst.f pssyntrd.f  pssyttrd.f pssytd2.f pssytrd.f 
   pstrti2.f pstrtri.f pstrtrs.f 
   pslaevswp.f 
   pslarzb.f pslarzt.f pslarz.f pslatrz.f pstzrzf.f psormr3.f psormrz.f 
   pslahqr.f pslaconsb.f pslacp3.f pslawil.f 
   pslasmsub.f pslared2d.f pslamr1d.f slaref.f slamsh.f slasorte.f ssteqr2.f 
   sdbtf2.f  sdbtrf.f  sdttrf.f sdttrsv.f spttrsv.f strmvt.f pssyevr.f
   bslaapp.f bslaexc.f bstrexc.f pstrord.f pstrsen.f psgebal.f pshseqr.f
   pslamve.f pslaqr0.f pslaqr1.f pslaqr2.f pslaqr3.f pslaqr4.f pslaqr5.f
   psrot.f slaqr6.f)
   
set (CLASRC  
   pcdbsv.f  pcdbtrf.f pcdbtrs.f pcdbtrsv.f 
   pcdtsv.f  pcdttrf.f pcdttrs.f pcdttrsv.f 
   pcgbsv.f  pcgbtrf.f pcgbtrs.f 
   pcgebd2.f pcgebrd.f pcgecon.f pctrcon.f pcgeequ.f pcgehd2.f pcgehrd.f
   pcgelq2.f pcgelqf.f  pcgels.f pcgeql2.f pcgeqlf.f pcgeqpf.f pcgeqr2.f 
   pcgeqrf.f pcgerfs.f pcgerq2.f pcgerqf.f                               
   pcgesv.f  pcgesvd.f pcgesvx.f pcgetf2.f pcgetrf.f pcgetri.f pcgetrs.f 
   pcggqrf.f 
   pcggrqf.f pcheev.f  pcheevd.f pcheevx.f pchegs2.f pchegst.f pchegvx.f 
   pchengst.f pchentrd.f pchettrd.f pchetd2.f 
   pchetrd.f pclabrd.f pclacon.f pclacgv.f pclacp2.f pclacpy.f pclahrd.f 
   pclahqr.f pclaconsb.f pclasmsub.f pclacp3.f pclawil.f
   pclange.f pclanhe.f pclanhs.f pclansy.f pclantr.f pclapiv.f pclapv2.f 
   pclaqge.f pclaqsy.f pclarf.f  pclarfb.f pclarfc.f pclarfg.f pclarft.f 
   pclascl.f pclase2.f pclaset.f pclassq.f pclaswp.f pclatra.f pclatrd.f 
   pclatrs.f pclauu2.f pclauum.f pcpocon.f pcpoequ.f pcporfs.f pcposv.f  
   pcpbsv.f  pcpbtrf.f pcpbtrs.f pcpbtrsv.f 
   pcptsv.f  pcpttrf.f pcpttrs.f pcpttrsv.f 
   pcposvx.f pcpotf2.f pcpotrf.f pcpotri.f pcpotrs.f pcsrscl.f pcstein.f 
   pctrevc.f pctrti2.f pctrtri.f pctrtrs.f pcung2l.f pcung2r.f 
             pcungl2.f pcunglq.f pcungql.f pcungqr.f pcungr2.f pcungrq.f 
             pcunm2l.f pcunm2r.f pcunmbr.f pcunmhr.f pcunml2.f pcunmlq.f 
   pcunmql.f pcunmqr.f pcunmr2.f pcunmrq.f pcunmtr.f 
   pclaevswp.f 
   pclarzb.f pclarzt.f pclarz.f  pclarzc.f pclatrz.f pctzrzf.f 
   pclattrs.f 
   pcunmr3.f pcunmrz.f pcmax1.f pscsum1.f pclamr1d.f 
   cdbtf2.f  cdbtrf.f  cdttrf.f cdttrsv.f  cpttrsv.f csteqr2.f ctrmvt.f 
   clamsh.f  claref.f  clanv2.f clahqr2.f pcheevr.f)

set (DLASRC  
   pddbsv.f  pddbtrf.f pddbtrs.f pddbtrsv.f 
   pddtsv.f  pddttrf.f pddttrs.f pddttrsv.f 
   pdgbsv.f  pdgbtrf.f pdgbtrs.f 
   pdgebd2.f pdgebrd.f pdgecon.f pdtrcon.f pdgeequ.f pdgehd2.f pdgehrd.f
   pdgelq2.f pdgelqf.f pdgels.f  pdgeql2.f pdgeqlf.f pdgeqpf.f pdgeqr2.f 
   pdgeqrf.f pdgerfs.f pdgerq2.f pdgerqf.f                               
   pdgesv.f  pdgesvd.f pdgesvx.f pdgetf2.f pdgetrf.f pdgetri.f pdgetrs.f 
   pdggqrf.f pdggrqf.f pdlabrd.f 
   pdlacon.f pdlacp2.f pdlacpy.f pdlahrd.f pdlange.f pdlanhs.f pdlansy.f 
   pdlantr.f pdlapiv.f pdlapv2.f pdlaqge.f pdlaqsy.f pdlarf.f  pdlarfb.f 
   pdlarfg.f pdlarft.f pdlase2.f pdlaset.f pdlascl.f pdlassq.f pdlaswp.f 
   pdlatra.f pdlatrd.f pdlatrs.f pdlauu2.f pdlauum.f pdorg2l.f pdorg2r.f 
                       pdorgl2.f pdorglq.f pdorgql.f pdorgqr.f pdorgr2.f 
   pdorgrq.f           pdorm2l.f pdorm2r.f pdormbr.f pdormhr.f pdorml2.f 
   pdormlq.f pdormql.f pdormqr.f pdormr2.f pdormrq.f pdormtr.f pdpocon.f 
   pdpbsv.f  pdpbtrf.f pdpbtrs.f pdpbtrsv.f 
   pdptsv.f  pdpttrf.f pdpttrs.f pdpttrsv.f 
   pdpoequ.f pdporfs.f pdposv.f  pdposvx.f pdpotf2.f pdpotrf.f pdpotri.f 
   pdpotrs.f pdrscl.f  pdstein.f pdsyev.f  pdsyevd.f pdsyevx.f 
   pdsygs2.f pdsygst.f 
   pdsygvx.f pdsyngst.f pdsyntrd.f pdsyttrd.f pdsytd2.f pdsytrd.f pdtrti2.f 
   pdtrtri.f pdtrtrs.f 
   pdlaevswp.f 
   pdlarzb.f pdlarzt.f pdlarz.f pdlatrz.f pdtzrzf.f pdormr3.f pdormrz.f 
   pdlahqr.f pdlaconsb.f pdlacp3.f pdlawil.f 
   pdlasmsub.f pdlared2d.f pdlamr1d.f dlaref.f dlamsh.f dlasorte.f dsteqr2.f 
   ddbtf2.f  ddbtrf.f  ddttrf.f ddttrsv.f dpttrsv.f dtrmvt.f  pdsyevr.f
   bdlaapp.f bdlaexc.f bdtrexc.f dlaqr6.f pdtrord.f
   pdtrsen.f pdgebal.f pdhseqr.f pdlamve.f pdlaqr0.f pdlaqr1.f pdlaqr2.f
   pdlaqr3.f pdlaqr4.f pdlaqr5.f pdrot.f)

set (ZLASRC  
   pzdbsv.f  pzdbtrf.f pzdbtrs.f pzdbtrsv.f 
   pzdtsv.f  pzdttrf.f pzdttrs.f pzdttrsv.f 
   pzgbsv.f  pzgbtrf.f pzgbtrs.f 
   pzgebd2.f pzgebrd.f pzgecon.f pztrcon.f pzgeequ.f pzgehd2.f pzgehrd.f
   pzgelq2.f pzgelqf.f pzgels.f  pzgeql2.f pzgeqlf.f pzgeqpf.f pzgeqr2.f 
   pzgeqrf.f pzgerfs.f pzgerq2.f pzgerqf.f                               
   pzgesv.f  pzgesvd.f pzgesvx.f pzgetf2.f pzgetrf.f pzgetri.f pzgetrs.f 
   pzggqrf.f 
   pzggrqf.f pzheev.f  pzheevd.f pzheevx.f pzhegs2.f pzhegst.f pzhegvx.f 
   pzhengst.f pzhentrd.f pzhettrd.f pzhetd2.f 
   pzhetrd.f pzlabrd.f pzlacon.f pzlacgv.f pzlacp2.f pzlacpy.f pzlahrd.f 
   pzlahqr.f pzlaconsb.f pzlasmsub.f pzlacp3.f pzlawil.f 
   pzlange.f pzlanhe.f pzlanhs.f pzlansy.f pzlantr.f pzlapiv.f pzlapv2.f 
   pzlaqge.f pzlaqsy.f pzlarf.f  pzlarfb.f pzlarfc.f pzlarfg.f pzlarft.f 
   pzlascl.f pzlase2.f pzlaset.f pzlassq.f pzlaswp.f pzlatra.f pzlatrd.f 
   pzlattrs.f 
   pzlatrs.f pzlauu2.f pzlauum.f pzpocon.f pzpoequ.f pzporfs.f pzposv.f  
   pzpbsv.f  pzpbtrf.f pzpbtrs.f pzpbtrsv.f 
   pzptsv.f  pzpttrf.f pzpttrs.f pzpttrsv.f 
   pzposvx.f pzpotf2.f pzpotrf.f pzpotri.f pzpotrs.f pzdrscl.f pzstein.f 
   pztrevc.f pztrti2.f pztrtri.f pztrtrs.f pzung2l.f pzung2r.f 
             pzungl2.f pzunglq.f pzungql.f pzungqr.f pzungr2.f pzungrq.f 
             pzunm2l.f pzunm2r.f pzunmbr.f pzunmhr.f pzunml2.f pzunmlq.f 
   pzunmql.f pzunmqr.f pzunmr2.f pzunmrq.f pzunmtr.f 
   pzlaevswp.f 
   pzlarzb.f pzlarzt.f pzlarz.f  pzlarzc.f pzlatrz.f pztzrzf.f 
   pzunmr3.f pzunmrz.f pzmax1.f pdzsum1.f pzlamr1d.f 
   zdbtf2.f  zdbtrf.f  zdttrf.f zdttrsv.f  zpttrsv.f zsteqr2.f ztrmvt.f 
   zlamsh.f  zlaref.f  zlanv2.f zlahqr2.f pzheevr.f)
   
set(src 
      ${ALLAUX} ${SCLAUX} ${DZLAUX}
      ${SLASRC} ${CLASRC} ${DLASRC} ${ZLASRC} )
set(src-C 
      ${ALLAUX-C} )

=== SRC/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         SRC Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../SLmake.inc

#######################################################################
#  This is the makefile to create a library for ScaLAPACK.
#  The files are organized as follows:
#       ALLAUX -- Auxiliary routines called from all precisions
#       SCLAUX -- Auxiliary routines called from both REAL and COMPLEX
#       DZLAUX -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#       SLASRC -- Single precision real ScaLAPACK routines
#       CLASRC -- Single precision complex ScaLAPACK routines
#       DLASRC -- Double precision real ScaLAPACK routines
#       ZLASRC -- Double precision complex ScaLAPACK routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ARCH, ARCHFLAGS, RANLIB,
#  FC and FCFLAGS definitions in ../SLmake.inc to match your library
#  archiver, compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is defined by ../$(SCALAPACKLIB) in
#  ../SLmake.inc and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

ALLAUX = pjlaenv.o pbchkvect.o getpbbuf.o pilaenvx.o piparmq.o pilaver.o pmpim2.o pmpcol.o

SCLAUX = \
   pslabad.o pslaed0.o pslaed1.o pslaed2.o pslaed3.o pslaedz.o pslaiect.o \
   pslamch.o pslared1d.o pslasrt.o psstebz.o psstedc.o slapst.o slasrt2.o \
   sstein2.o \
   slar1va.o slarrb2.o slarrd2.o slarre2.o slarre2a.o slarrf2.o \
   slarrv2.o sstegr2.o sstegr2a.o sstegr2b.o slamov.o clamov.o

DZLAUX = \
   pdlabad.o pdlaed0.o pdlaed1.o pdlaed2.o pdlaed3.o pdlaedz.o pdlaiect.o \
   pdlamch.o pdlared1d.o pdlasrt.o pdstebz.o pdstedc.o dlapst.o dlasrt2.o \
   dstein2.o \
   dlar1va.o dlarrb2.o dlarrd2.o dlarre2.o dlarre2a.o dlarrf2.o \
   dlarrv2.o dstegr2.o dstegr2a.o dstegr2b.o dlamov.o zlamov.o

SLASRC = \
   psdbsv.o  psdbtrf.o psdbtrs.o psdbtrsv.o \
   psdtsv.o  psdttrf.o psdttrs.o psdttrsv.o \
   psgbsv.o  psgbtrf.o psgbtrs.o \
   psgebd2.o psgebrd.o psgecon.o pstrcon.o psgeequ.o psgehd2.o psgehrd.o \
   psgelq2.o psgelqf.o psgels.o  psgeql2.o psgeqlf.o psgeqpf.o psgeqr2.o \
   psgeqrf.o psgerfs.o psgerq2.o psgerqf.o                               \
   psgesv.o  psgesvd.o psgesvx.o psgetf2.o psgetrf.o psgetri.o psgetrs.o \
   psggqrf.o psggrqf.o pslabrd.o \
   pslacon.o pslacp2.o pslacpy.o pslahrd.o pslange.o pslanhs.o pslansy.o \
   pslantr.o pslapiv.o pslapv2.o pslaqge.o pslaqsy.o pslarf.o  pslarfb.o \
   pslarfg.o pslarft.o pslase2.o pslaset.o pslascl.o pslassq.o pslaswp.o \
   pslatra.o pslatrd.o pslatrs.o pslauu2.o pslauum.o psorg2l.o psorg2r.o \
                       psorgl2.o psorglq.o psorgql.o psorgqr.o psorgr2.o \
   psorgrq.o           psorm2l.o psorm2r.o psormbr.o psormhr.o psorml2.o \
   psormlq.o psormql.o psormqr.o psormr2.o psormrq.o psormtr.o pspocon.o \
   pspbsv.o  pspbtrf.o pspbtrs.o pspbtrsv.o \
   psptsv.o  pspttrf.o pspttrs.o pspttrsv.o \
   pspoequ.o psporfs.o psposv.o  psposvx.o pspotf2.o pspotrf.o pspotri.o \
   pspotrs.o psrscl.o  psstein.o pssyev.o  pssyevd.o pssyevx.o \
   pssygs2.o pssygst.o \
   pssygvx.o pssyngst.o pssyntrd.o  pssyttrd.o pssytd2.o pssytrd.o \
   pstrti2.o pstrtri.o pstrtrs.o \
   pslaevswp.o \
   pslarzb.o pslarzt.o pslarz.o pslatrz.o pstzrzf.o psormr3.o psormrz.o \
   pslahqr.o pslaconsb.o pslacp3.o pslawil.o \
   pslasmsub.o pslared2d.o pslamr1d.o slaref.o slamsh.o slasorte.o ssteqr2.o \
   sdbtf2.o  sdbtrf.o  sdttrf.o sdttrsv.o spttrsv.o strmvt.o pssyevr.o \
   bslaapp.o bslaexc.o bstrexc.o pstrord.o pstrsen.o psgebal.o pshseqr.o \
   pslamve.o pslaqr0.o pslaqr1.o pslaqr2.o pslaqr3.o pslaqr4.o pslaqr5.o \
   psrot.o slaqr6.o

CLASRC = \
   pcdbsv.o  pcdbtrf.o pcdbtrs.o pcdbtrsv.o \
   pcdtsv.o  pcdttrf.o pcdttrs.o pcdttrsv.o \
   pcgbsv.o  pcgbtrf.o pcgbtrs.o \
   pcgebd2.o pcgebrd.o pcgecon.o pctrcon.o pcgeequ.o pcgehd2.o pcgehrd.o \
   pcgelq2.o pcgelqf.o  pcgels.o pcgeql2.o pcgeqlf.o pcgeqpf.o pcgeqr2.o \
   pcgeqrf.o pcgerfs.o pcgerq2.o pcgerqf.o                               \
   pcgesv.o  pcgesvd.o pcgesvx.o pcgetf2.o pcgetrf.o pcgetri.o pcgetrs.o \
   pcggqrf.o \
   pcggrqf.o pcheev.o  pcheevd.o pcheevx.o pchegs2.o pchegst.o pchegvx.o \
   pchengst.o pchentrd.o pchettrd.o pchetd2.o \
   pchetrd.o pclabrd.o pclacon.o pclacgv.o pclacp2.o pclacpy.o pclahrd.o \
   pclahqr.o pclaconsb.o pclasmsub.o pclacp3.o pclawil.o pcrot.o \
   pclange.o pclanhe.o pclanhs.o pclansy.o pclantr.o pclapiv.o pclapv2.o \
   pclaqge.o pclaqsy.o pclarf.o  pclarfb.o pclarfc.o pclarfg.o pclarft.o \
   pclascl.o pclase2.o pclaset.o pclassq.o pclaswp.o pclatra.o pclatrd.o \
   pclatrs.o pclauu2.o pclauum.o pcpocon.o pcpoequ.o pcporfs.o pcposv.o  \
   pcpbsv.o  pcpbtrf.o pcpbtrs.o pcpbtrsv.o \
   pcptsv.o  pcpttrf.o pcpttrs.o pcpttrsv.o \
   pcposvx.o pcpotf2.o pcpotrf.o pcpotri.o pcpotrs.o pcsrscl.o pcstein.o \
   pctrevc.o pctrti2.o pctrtri.o pctrtrs.o pcung2l.o pcung2r.o \
             pcungl2.o pcunglq.o pcungql.o pcungqr.o pcungr2.o pcungrq.o \
             pcunm2l.o pcunm2r.o pcunmbr.o pcunmhr.o pcunml2.o pcunmlq.o \
   pcunmql.o pcunmqr.o pcunmr2.o pcunmrq.o pcunmtr.o \
   pclaevswp.o \
   pclarzb.o pclarzt.o pclarz.o  pclarzc.o pclatrz.o pctzrzf.o \
   pclattrs.o \
   pcunmr3.o pcunmrz.o pcmax1.o pscsum1.o pclamr1d.o \
   cdbtf2.o  cdbtrf.o  cdttrf.o cdttrsv.o  cpttrsv.o csteqr2.o ctrmvt.o \
   clamsh.o  claref.o  clanv2.o clahqr2.o pcheevr.o

DLASRC = \
   pddbsv.o  pddbtrf.o pddbtrs.o pddbtrsv.o \
   pddtsv.o  pddttrf.o pddttrs.o pddttrsv.o \
   pdgbsv.o  pdgbtrf.o pdgbtrs.o \
   pdgebd2.o pdgebrd.o pdgecon.o pdtrcon.o pdgeequ.o pdgehd2.o pdgehrd.o \
   pdgelq2.o pdgelqf.o pdgels.o  pdgeql2.o pdgeqlf.o pdgeqpf.o pdgeqr2.o \
   pdgeqrf.o pdgerfs.o pdgerq2.o pdgerqf.o                               \
   pdgesv.o  pdgesvd.o pdgesvx.o pdgetf2.o pdgetrf.o pdgetri.o pdgetrs.o \
   pdggqrf.o pdggrqf.o pdlabrd.o \
   pdlacon.o pdlacp2.o pdlacpy.o pdlahrd.o pdlange.o pdlanhs.o pdlansy.o \
   pdlantr.o pdlapiv.o pdlapv2.o pdlaqge.o pdlaqsy.o pdlarf.o  pdlarfb.o \
   pdlarfg.o pdlarft.o pdlase2.o pdlaset.o pdlascl.o pdlassq.o pdlaswp.o \
   pdlatra.o pdlatrd.o pdlatrs.o pdlauu2.o pdlauum.o pdorg2l.o pdorg2r.o \
                       pdorgl2.o pdorglq.o pdorgql.o pdorgqr.o pdorgr2.o \
   pdorgrq.o           pdorm2l.o pdorm2r.o pdormbr.o pdormhr.o pdorml2.o \
   pdormlq.o pdormql.o pdormqr.o pdormr2.o pdormrq.o pdormtr.o pdpocon.o \
   pdpbsv.o  pdpbtrf.o pdpbtrs.o pdpbtrsv.o \
   pdptsv.o  pdpttrf.o pdpttrs.o pdpttrsv.o \
   pdpoequ.o pdporfs.o pdposv.o  pdposvx.o pdpotf2.o pdpotrf.o pdpotri.o \
   pdpotrs.o pdrscl.o  pdstein.o pdsyev.o  pdsyevd.o pdsyevx.o \
   pdsygs2.o pdsygst.o \
   pdsygvx.o pdsyngst.o pdsyntrd.o pdsyttrd.o pdsytd2.o pdsytrd.o pdtrti2.o \
   pdtrtri.o pdtrtrs.o \
   pdlaevswp.o \
   pdlarzb.o pdlarzt.o pdlarz.o pdlatrz.o pdtzrzf.o pdormr3.o pdormrz.o \
   pdlahqr.o pdlaconsb.o pdlacp3.o pdlawil.o \
   pdlasmsub.o pdlared2d.o pdlamr1d.o dlaref.o dlamsh.o dlasorte.o dsteqr2.o \
   ddbtf2.o  ddbtrf.o  ddttrf.o ddttrsv.o dpttrsv.o dtrmvt.o pdsyevr.o \
   bdlaapp.o bdlaexc.o bdtrexc.o dlaqr6.o pdtrord.o \
   pdtrsen.o pdgebal.o pdhseqr.o pdlamve.o pdlaqr0.o pdlaqr1.o pdlaqr2.o \
   pdlaqr3.o pdlaqr4.o pdlaqr5.o pdrot.o

ZLASRC = \
   pzdbsv.o  pzdbtrf.o pzdbtrs.o pzdbtrsv.o \
   pzdtsv.o  pzdttrf.o pzdttrs.o pzdttrsv.o \
   pzgbsv.o  pzgbtrf.o pzgbtrs.o \
   pzgebd2.o pzgebrd.o pzgecon.o pztrcon.o pzgeequ.o pzgehd2.o pzgehrd.o \
   pzgelq2.o pzgelqf.o pzgels.o  pzgeql2.o pzgeqlf.o pzgeqpf.o pzgeqr2.o \
   pzgeqrf.o pzgerfs.o pzgerq2.o pzgerqf.o                               \
   pzgesv.o  pzgesvd.o pzgesvx.o pzgetf2.o pzgetrf.o pzgetri.o pzgetrs.o \
   pzggqrf.o \
   pzggrqf.o pzheev.o  pzheevd.o pzheevx.o pzhegs2.o pzhegst.o pzhegvx.o \
   pzhengst.o pzhentrd.o pzhettrd.o pzhetd2.o \
   pzhetrd.o pzlabrd.o pzlacon.o pzlacgv.o pzlacp2.o pzlacpy.o pzlahrd.o \
   pzlahqr.o pzlaconsb.o pzlasmsub.o pzlacp3.o pzlawil.o pzrot.o \
   pzlange.o pzlanhe.o pzlanhs.o pzlansy.o pzlantr.o pzlapiv.o pzlapv2.o \
   pzlaqge.o pzlaqsy.o pzlarf.o  pzlarfb.o pzlarfc.o pzlarfg.o pzlarft.o \
   pzlascl.o pzlase2.o pzlaset.o pzlassq.o pzlaswp.o pzlatra.o pzlatrd.o \
   pzlattrs.o \
   pzlatrs.o pzlauu2.o pzlauum.o pzpocon.o pzpoequ.o pzporfs.o pzposv.o  \
   pzpbsv.o  pzpbtrf.o pzpbtrs.o pzpbtrsv.o \
   pzptsv.o  pzpttrf.o pzpttrs.o pzpttrsv.o \
   pzposvx.o pzpotf2.o pzpotrf.o pzpotri.o pzpotrs.o pzdrscl.o pzstein.o \
   pztrevc.o pztrti2.o pztrtri.o pztrtrs.o pzung2l.o pzung2r.o \
             pzungl2.o pzunglq.o pzungql.o pzungqr.o pzungr2.o pzungrq.o \
             pzunm2l.o pzunm2r.o pzunmbr.o pzunmhr.o pzunml2.o pzunmlq.o \
   pzunmql.o pzunmqr.o pzunmr2.o pzunmrq.o pzunmtr.o \
   pzlaevswp.o \
   pzlarzb.o pzlarzt.o pzlarz.o  pzlarzc.o pzlatrz.o pztzrzf.o \
   pzunmr3.o pzunmrz.o pzmax1.o pdzsum1.o pzlamr1d.o \
   zdbtf2.o  zdbtrf.o  zdttrf.o zdttrsv.o  zpttrsv.o zsteqr2.o ztrmvt.o \
   zlamsh.o  zlaref.o  zlanv2.o zlahqr2.o pzheevr.o

all: single complex double complex16

single: $(SLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(SLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

complex: $(CLASRC) $(SCLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(CLASRC) $(SCLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

double: $(DLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(DLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

complex16: $(ZLASRC) $(DZLAUX) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(ZLASRC) $(DZLAUX) \
	$(ALLAUX)
	$(RANLIB) ../$(SCALAPACKLIB)

slamov.o: slamov.c
dlamov.o: dlamov.c
clamov.o: clamov.c
zlamov.o: zlamov.c
slamov.o dlamov.o clamov.o zlamov.o: lamov.h
	$(CC) -c $(CFLAGS) $(CDEFS) $(@:.o=.c) -o $@

clean :
	rm -f *.o

.f.o : 
	$(FC) -c $(FCFLAGS) $*.f

.c.o : 
	$(CC) -c $(CDEFS) $(CCFLAGS) $*.c

=== TOOLS/Makefile ===
############################################################################
#
#  Program:         ScaLAPACK
#
#  Module:          Makefile
#
#  Purpose:         Tools Makefile
#
#  Creation date:   March 20, 1995
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../SLmake.inc

ATOOLS = iceil.o      ilacpy.o     ilcm.o       indxg2p.o    indxg2l.o    \
         indxl2g.o    infog1l.o    infog2l.o    npreroc.o    numroc.o     \
         chk1mat.o    pchkxmat.o   sltimer.o    desc_convert.o \
         descinit.o   descset.o    reshape.o    SL_gridreshape.o \
         SL_init.o

ITOOLS = picol2row.o  pirow2col.o  pilaprnt.o   pitreecomb.o  pifillpad.o  \
         pichekpad.o  pielset.o    pielset2.o   pielget.o

STOOLS = dsnrm2.o     dsasum.o     slatcpy.o    ssdot.o       smatadd.o   \
         psmatadd.o   pscol2row.o  psrow2col.o  pslaprnt.o    pstreecomb.o \
         psfillpad.o  pschekpad.o  pselset.o    pselset2.o    pselget.o \
         pslaread.o   pslawrite.o

DTOOLS = dddot.o      dlatcpy.o    dmatadd.o    pdmatadd.o    pdcol2row.o \
         pdrow2col.o  pdlaprnt.o   pdtreecomb.o pdfillpad.o   pdchekpad.o \
         pdelset.o    pdelset2.o   pdelget.o \
         pdlaread.o   pdlawrite.o

CTOOLS = dscnrm2.o    dscasum.o    ccdotu.o     ccdotc.o      clatcpy.o \
         cmatadd.o    pcmatadd.o   pccol2row.o  pcrow2col.o   pclaprnt.o \
         pctreecomb.o pcfillpad.o  pcchekpad.o  pcelset.o     pcelset2.o \
         pcelget.o \
         pclaread.o   pclawrite.o

ZTOOLS = zzdotu.o     zzdotc.o     zlatcpy.o    zmatadd.o     pzmatadd.o \
         pzcol2row.o  pzrow2col.o  pzlaprnt.o   pztreecomb.o  pzfillpad.o \
         pzchekpad.o  pzelset.o    pzelset2.o   pzelget.o \
         pzlaread.o   pzlawrite.o

all: single double complex complex16

slapackaux:
	( cd LAPACK; $(MAKE) single )

dlapackaux:
	( cd LAPACK; $(MAKE) double )

clapackaux:
	( cd LAPACK; $(MAKE) complex )

zlapackaux:
	( cd LAPACK; $(MAKE) complex16 )

integer: $(ATOOLS) $(ITOOLS)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(ATOOLS) $(ITOOLS)
	$(RANLIB) ../$(SCALAPACKLIB)

single: slapackaux integer $(STOOLS)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(STOOLS)
	$(RANLIB) ../$(SCALAPACKLIB)

double: dlapackaux integer $(DTOOLS)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(DTOOLS)
	$(RANLIB) ../$(SCALAPACKLIB)

complex: clapackaux integer $(CTOOLS)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(CTOOLS)
	$(RANLIB) ../$(SCALAPACKLIB)

complex16: zlapackaux integer $(ZTOOLS)
	$(ARCH) $(ARCHFLAGS) ../$(SCALAPACKLIB) $(ZTOOLS)
	$(RANLIB) ../$(SCALAPACKLIB)

clean :
	rm -f *.o
	( cd LAPACK; $(MAKE) clean )

.f.o : ; $(FC) -c $(FCFLAGS) $*.f

.c.o : ; $(CC) -c $(CDEFS) $(CCFLAGS) $*.c

=== BLACS/SRC/CMakeLists.txt ===
#  --------------------------
#  The communication routines
#  --------------------------
set (comm
       igesd2d_.c sgesd2d_.c dgesd2d_.c cgesd2d_.c zgesd2d_.c 	
       itrsd2d_.c strsd2d_.c dtrsd2d_.c ctrsd2d_.c ztrsd2d_.c 
       igerv2d_.c sgerv2d_.c dgerv2d_.c cgerv2d_.c zgerv2d_.c 
       itrrv2d_.c strrv2d_.c dtrrv2d_.c ctrrv2d_.c ztrrv2d_.c 
       igebs2d_.c sgebs2d_.c dgebs2d_.c cgebs2d_.c zgebs2d_.c 
       igebr2d_.c sgebr2d_.c dgebr2d_.c cgebr2d_.c zgebr2d_.c 
       itrbs2d_.c strbs2d_.c dtrbs2d_.c ctrbs2d_.c ztrbs2d_.c 
       itrbr2d_.c strbr2d_.c dtrbr2d_.c ctrbr2d_.c ztrbr2d_.c 
       igsum2d_.c sgsum2d_.c dgsum2d_.c cgsum2d_.c zgsum2d_.c 
       igamx2d_.c sgamx2d_.c dgamx2d_.c cgamx2d_.c zgamx2d_.c 
       igamn2d_.c sgamn2d_.c dgamn2d_.c cgamn2d_.c zgamn2d_.c)

#  --------------------
#  The support routines
#  --------------------
set (supp
       blacs_setup_.c blacs_set_.c blacs_get_.c
       blacs_abort_.c blacs_exit_.c blacs_pnum_.c blacs_pcoord_.c
       ksendid_.c krecvid_.c kbsid_.c kbrid_.c
       dcputime00_.c dwalltime00_.c blacs_pinfo_.c
       blacs_init_.c blacs_map_.c blacs_free_.c blacs_grid_.c blacs_info_.c
       blacs_barr_.c sys2blacs_.c blacs2sys_.c free_handle_.c)

#  ---------------------
#  The internal routines
#  ---------------------
set (internal
           BI_HypBS.c BI_HypBR.c BI_IdringBS.c BI_IdringBR.c
           BI_MpathBS.c BI_MpathBR.c BI_SringBS.c BI_SringBR.c
           BI_TreeBS.c BI_TreeBR.c
           BI_Ssend.c BI_Rsend.c BI_Srecv.c BI_Asend.c BI_Arecv.c
           BI_TreeComb.c BI_BeComb.c BI_MringComb.c
           BI_ArgCheck.c BI_TransDist.c BI_GetBuff.c BI_UpdateBuffs.c
           BI_EmergencyBuff.c BI_BlacsErr.c BI_BlacsWarn.c BI_BlacsAbort.c
           BI_BuffIsFree.c BI_imvcopy.c BI_smvcopy.c BI_dmvcopy.c
           BI_ivmcopy.c BI_svmcopy.c BI_dvmcopy.c
           BI_Pack.c BI_Unpack.c BI_GetMpiGeType.c BI_GetMpiTrType.c
           BI_ivvsum.c BI_svvsum.c BI_dvvsum.c BI_cvvsum.c BI_zvvsum.c
           BI_ivvamx.c BI_svvamx.c BI_dvvamx.c BI_cvvamx.c BI_zvvamx.c
           BI_ivvamx2.c BI_svvamx2.c BI_dvvamx2.c BI_cvvamx2.c BI_zvvamx2.c
           BI_ivvamn.c BI_svvamn.c BI_dvvamn.c BI_cvvamn.c BI_zvvamn.c
           BI_ivvamn2.c BI_svvamn2.c BI_dvvamn2.c BI_cvvamn2.c BI_zvvamn2.c
           BI_iMPI_amx.c BI_sMPI_amx.c BI_dMPI_amx.c BI_cMPI_amx.c
           BI_zMPI_amx.c BI_iMPI_amx2.c BI_sMPI_amx2.c BI_dMPI_amx2.c
           BI_cMPI_amx2.c BI_zMPI_amx2.c BI_iMPI_amn.c BI_sMPI_amn.c
           BI_dMPI_amn.c BI_cMPI_amn.c BI_zMPI_amn.c BI_iMPI_amn2.c
           BI_sMPI_amn2.c BI_dMPI_amn2.c BI_cMPI_amn2.c BI_zMPI_amn2.c
           BI_cMPI_sum.c BI_zMPI_sum.c BI_ContxtNum.c BI_GlobalVars.c
           BI_TransUserComm.c )


#
# Note on CMAKE (from Brad - Kitware)
#
#CMake hides the intermediate object files from its interface so there is
#no direct way to do this within a single target.  This limitation comes
#from the requirement to support generation of build systems like VS IDE
#project files that do not expose object files explicitly.

# Solution 1 : Build separate libraries, one for each block of objects
#set(blacsFint ${comm} ${supp})
#add_library(blacsCint ${comm} ${supp})
#set_property(TARGET blacsCint PROPERTY COMPILE_DEFINITIONS CallFromC)
#add_library(scalapack ${internal} ${blacsFint})
#target_link_libraries(scalapack blacsCint)

# Solution 2 : Create an extra source file that #include-s the original one
set(srcs ${comm} ${supp})
set(srcs_C)
foreach(src ${srcs})
#  string(REPLACE ".c" "-C.c" src_C "${CMAKE_CURRENT_BINARY_DIR}/${src}")
  string(REPLACE ".c" "-C.c" src_C "${src}")
  configure_file(src-C.c.in ${src_C} @ONLY)
  list(APPEND srcs_C ${src_C})
endforeach()

set(blacs ${srcs} ${srcs_C} ${internal})
#add_library(scalapack ${srcs} ${srcs_C} ${internal})
#scalapack_install_library(scalapack)

=== BLACS/TESTING/CMakeLists.txt ===
set(FTestObj  
   blacstest.f btprim.f tools.f)

add_executable(xFbtest ${FTestObj})
target_link_libraries(xFbtest scalapack)

set(CTestObj  
   Cbt.c)

set_property(
   SOURCE Cbt.c
   APPEND PROPERTY COMPILE_DEFINITIONS BTCINTFACE
   )

add_executable(xCbtest ${CTestObj} ${FTestObj})
target_link_libraries(xCbtest scalapack)

file(COPY bsbr.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY bt.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY comb.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY sdrv.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)

# We could run the BLACS TESTING the following way
# But BLACS TESTING are TESTING anormal exit so even if they pass,
# CTest will determine they fail
#add_test(xFbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xFbtest)
#add_test(xCbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xCbtest)

add_test(xCbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DTEST_PROG=xCbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

add_test(xFbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DTEST_PROG=xFbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

=== BLACS/TESTING/Makefile ===
include ../../SLmake.inc

#  ---------------------------------------------------------------------
#  The file tools.f contains some LAPACK routines that the tester calls.
#  If you have ScaLAPACK, you may point to your tools library instead
#  of compiling this file.
#  ---------------------------------------------------------------------
tools = tools.o

exe : all
ctest : xCbtest
ftest : xFbtest
all : xCbtest xFbtest

obj = blacstest.o btprim.o

xCbtest: $(obj) $(tools)
	$(CC) -c $(CDEFS) $(CCFLAGS) -DBTCINTFACE Cbt.c
	$(FCLOADER) $(FCLOADFLAGS) -o $@ $(obj) $(tools) Cbt.o ../../$(SCALAPACKLIB)

xFbtest: $(obj) $(tools)
	$(FCLOADER) $(FCLOADFLAGS) -o $@ $(obj) $(tools) ../../$(SCALAPACKLIB)

#  --------------------------------------------------------------------
#  The files tools.f and blacstest.f are compiled without optimization.
#  Tools.f contains the LAPACK routines slamch and dlamch, which only
#  operate correctly for low-levels of optimization.  Blacstest.f is
#  extremely large, and optimizing it takes a long time.  More
#  importantly, the sun's f77 compiler seems to produce errors in
#  trying to optimize such a large file.  We therefore insist that it
#  also not be optimized.
#  --------------------------------------------------------------------
tools.o : tools.f
	$(FC) $(NOOPT) -c $*.f

blacstest.o : blacstest.f
	$(FC) $(NOOPT) -c $*.f

btprim.o : btprim.f
	$(FC) -c $(FCFLAGS) $*.f

clean :
	rm -f $(obj) tools.o Cbt.o xCbtest xFbtest

.f.o: ; $(FC) -c $(FCFLAGS) $*.f

.c.o:
	$(CC) -c $(CDEFS) $(CCFLAGS) $<

=== PBLAS/TIMING/CMakeLists.txt ===
file(COPY ../SRC/PTOOLS/PB_Cwarn.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(COPY ../SRC/PTOOLS/PB_Cabort.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})

set (PblasErrorHandler  PB_Cwarn.c PB_Cabort.c)
set (pbtcom pblastim.f ${PblasErrorHandler})
set (spbtcom psblastim.f ${pbtcom})
set (dpbtcom pdblastim.f ${pbtcom})
set (cpbtcom pcblastim.f ${pbtcom})
set (zpbtcom pzblastim.f ${pbtcom})
   
set_property(
   SOURCE ${PblasErrorHandler}
   APPEND PROPERTY COMPILE_DEFINITIONS TestingPblas 
   )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/PBLAS/TIMING)

file(COPY PCBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS1TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS2TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS3TIM.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})


add_executable(spb1tim psblas1tim.f ${spbtcom})
add_executable(dpb1tim pdblas1tim.f ${dpbtcom})
add_executable(cpb1tim pcblas1tim.f ${cpbtcom})
add_executable(zpb1tim pzblas1tim.f ${zpbtcom})

add_executable(spb2tim psblas2tim.f ${spbtcom})
add_executable(dpb2tim pdblas2tim.f ${dpbtcom})
add_executable(cpb2tim pcblas2tim.f ${cpbtcom})
add_executable(zpb2tim pzblas2tim.f ${zpbtcom})

add_executable(spb3tim psblas3tim.f ${spbtcom})
add_executable(dpb3tim pdblas3tim.f ${dpbtcom})
add_executable(cpb3tim pcblas3tim.f ${cpbtcom})
add_executable(zpb3tim pzblas3tim.f ${zpbtcom})

target_link_libraries(spb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb1tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(spb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb2tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(spb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb3tim scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

add_test(spb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb1tim)
add_test(dpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb1tim)
add_test(cpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb1tim)
add_test(zpb1tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb1tim)

add_test(spb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb2tim)
add_test(dpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb2tim)
add_test(cpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb2tim)
add_test(zpb2tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb2tim)

add_test(spb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb3tim)
add_test(dpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb3tim)
add_test(cpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb3tim)
add_test(zpb3tim ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb3tim)

=== REDIST/TESTING/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/scalapack/REDIST/TESTING)

file(COPY GEMR2D.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY TRMR2D.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

add_executable(xigemr pigemrdrv.c)
add_executable(xsgemr psgemrdrv.c)
add_executable(xdgemr pdgemrdrv.c)
add_executable(xcgemr pcgemrdrv.c)
add_executable(xzgemr pzgemrdrv.c)

add_executable(xitrmr pitrmrdrv.c)
add_executable(xstrmr pstrmrdrv.c)
add_executable(xdtrmr pdtrmrdrv.c)
add_executable(xctrmr pctrmrdrv.c)
add_executable(xztrmr pztrmrdrv.c)

target_link_libraries(xigemr scalapack )
target_link_libraries(xsgemr scalapack )
target_link_libraries(xdgemr scalapack )
target_link_libraries(xcgemr scalapack )
target_link_libraries(xzgemr scalapack )

target_link_libraries(xitrmr scalapack )
target_link_libraries(xstrmr scalapack )
target_link_libraries(xdtrmr scalapack )
target_link_libraries(xctrmr scalapack )
target_link_libraries(xztrmr scalapack )

#add_test(xigemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xigemr)
#add_test(xsgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xsgemr)
#add_test(xdgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xdgemr)
#add_test(xcgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xcgemr)
#add_test(xzgemr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xzgemr)

#add_test(xitrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xitrmr)
#add_test(xstrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xstrmr)
#add_test(xdtrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xdtrmr)
#add_test(xctrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xctrmr)
#add_test(xztrmr ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xztrmr)

=== debian/changelog ===
scalapack (2.1.0-4) unstable; urgency=medium

  * Team upload.
  * retrospectively place Adam C. Powell, IV's name in quotes
  * override lintian's breakout-link warning for scalapack-mpi-test.
    Test binaries in usr/lib look locally for test input files which
    are stored in usr/share, hence links are needed.
  * inject CMAKE_LIBRARY_ARCHITECTURE into
    scalapack-targets-none.cmake for arch-dep packages
    (libscalapack-*-dev) not arch-indep.
  * don't run full configure/build/test for arch-indep builds
    (scalapack-test-common does not need arch-dep binaries)

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Aug 2020 12:20:27 +0800

scalapack (2.1.0-3) unstable; urgency=medium

  * Team upload.
  * facilitate MPI tests using OMPI_MCA_plm_rsh_agent (set to false)
    not OMPI_MCA_orte_rsh_agent (which is deprecated)
  * build with fortran flag -std=legacy (in FFLAGS), applying
    upstream's method for managing builds with gcc-10. Closes: #957774.
  * replace arch-triplet with cmake's CMAKE_LIBRARY_ARCHITECTURE in
    installed scalapack-targets-none.cmake
  * Standards-Version: 4.5.0
  * debhelper compatibility level 13

 -- Drew Parsons <dparsons@debian.org>  Mon, 03 Aug 2020 01:44:46 +0800

scalapack (2.1.0-2) unstable; urgency=medium

  * Team upload.
  * upload new upstream release to unstable

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Dec 2019 17:48:16 +1100

scalapack (2.1.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release: updates version number in code.
    - update ABI to libscalapack-openmpi.so.2.1 with package
      libscalapack-openmpi2.1 (likewise libscalapack-mpich2.1)
  * set multiarch headers
    - Multi-Arch: same: libscalapack-mpi-dev,
       libscalapack-mpich-dev, libscalapack-openmpi-dev,
       libscalapack-openmpi2.1, libscalapack-mpich2.1,
       scalapack-mpi-test
    - Multi-Arch: foreign: scalapack-test-common

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Nov 2019 17:08:45 +0800

scalapack (2.1-1exp1) experimental; urgency=medium

  * Team upload.
  * update debian/watch to
    https://github.com/Reference-ScaLAPACK/scalapack
    (source tarballs are no longer accessible at
    http://www.netlib.org/scalapack/scalapack-2.1.tgz)
  * New upstream release.
    - update debian/copyight: BSD-3-clause
  * debhelper compatibility level 12: debhelper-compat (= 12)
  * Standards-Version: 4.4.1

 -- Drew Parsons <dparsons@debian.org>  Sun, 24 Nov 2019 23:20:38 +0800

scalapack (2.0.2-7) unstable; urgency=medium

  * Team upload.
  * Add mipsel to no-test list (tests pass on some machines,
    but not all)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Apr 2018 08:33:16 +0800

scalapack (2.0.2-6) unstable; urgency=medium

  * Team upload.
  * Don't run openmpi3 tests on arches where tests do not exit,
    or take too long to complete. Currently
    ARCH_NO_OPENMPI_TEST_LIST = armel armhf i386 hppa powerpc

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Apr 2018 15:07:18 +0800

scalapack (2.0.2-5) unstable; urgency=medium

  * Team upload.
  * Fix short description of libscalapack-mpi-dev: supports default
    MPI not (necessarily) MPICH.
  * Patch blacs_testing.patch allows for empty output strings
    when an error occurs.
  * Tests are hardwired to 4 processes, so ignore test failures if
    less than 4 processes are used. Pass MPIEXEC_PREFLAGS to tests,
    with --allow-run-as-root --oversubscribe to enable 4 processes to
    be handled if they are not otherwise available.
  * Standards-Version: 4.1.4
  * Update VCS tags to salsa.debian.org.

 -- Drew Parsons <dparsons@debian.org>  Sun, 22 Apr 2018 17:51:08 +0800

=== debian/control ===
Source: scalapack
Section: devel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Muammar El Khatib <muammar@debian.org>
Standards-Version: 4.5.0
Build-Depends: debhelper-compat (= 13),
 cmake, 
 mpi-default-dev,
 mpi-default-bin,
 libopenmpi-dev,
 mpich, libmpich-dev,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 pkg-config,
 chrpath
Homepage: http://www.netlib.org/scalapack/
Vcs-Git: https://salsa.debian.org/science-team/scalapack.git
Vcs-Browser: https://salsa.debian.org/science-team/scalapack

Package: libscalapack-openmpi2.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the 
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: libscalapack-mpich2.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the 
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-mpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${scalapack-mpi-dev}, mpi-default-dev, ${misc:Depends}
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This is a dummy package which depends on the scalapack development package
 supporting the default implementation of MPI on this architecture.

Package: libscalapack-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack-mpich2.1 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-openmpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack-openmpi2.1 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: scalapack-mpi-test
Section: math
Architecture: any
Multi-Arch: same
Depends: scalapack-test-common, ${shlibs:Depends}, ${misc:Depends}
Recommends: cmake
Conflicts: scalapack-mpich-test
Replaces: scalapack-mpich-test, blacs-mpi-test
Provides: scalapack-mpich-test, blacs-mpi-test
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Test files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains ScaLAPACK, PBLAS and BLACS test programs.

Package: scalapack-test-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: blacs-test-common
Provides: blacs-test-common
Suggests: scalapack-mpi-test
Description: Test data for ScaLAPACK testers
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains data files used by test programs.

=== debian/rules ===
#! /usr/bin/make -f


# eventually add -O3 -march=native -mtune=native
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_FFLAGS_MAINT_APPEND  = -std=legacy
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)

ifneq (,$(wildcard /usr/share/mpi-default-dev/debian_defaults))
include /usr/share/mpi-default-dev/debian_defaults 
endif
DEFAULT_MPI=$(ARCH_DEFAULT_MPI_IMPL)

%:
	dh $@ --buildsystem=cmake

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

disable_mpi_archs = armel armhf kfreebsd-amd64 kfreebsd-i386 mips mipsel
export LD_LIBRARY_PATH :=  $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH); 

export NUMJOBS=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
export NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

extra_flags += \
 -DBUILD_SHARED_LIBS=ON


override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:
override_dh_auto_test-indep:


override_dh_auto_configure-arch:
	for flavor in openmpi mpich; do \
          echo "Configure for libscalapack-$$flavor" ; \
          dh_auto_configure --builddirectory=build-$$flavor -- $(extra_flags) -DMPI_C_COMPILER=mpicc.$$flavor -DMPI_Fortran_COMPILER=mpif90.$$flavor -DMPI_FLAVOR=$$flavor ; \
	done

override_dh_auto_build-arch:
	for flavor in openmpi mpich; do \
	  echo "Building libscalapack-$$flavor" ; \
	  dh_auto_build -O--parallel --builddirectory=build-$$flavor ; \
	done

override_dh_auto_install-arch:
	echo "scalapack-mpi-dev=libscalapack-$(DEFAULT_MPI)-dev" > debian/libscalapack-mpi-dev.substvars
	for flavor in openmpi mpich; do \
	  echo "Installing scalapack-$$flavor" ; \
	  dh_auto_install -O--parallel --builddirectory=build-$$flavor ; \
	  sed "s/-lscalapack/-lscalapack-$$flavor/; s|/usr/lib|/usr/lib/$(DEB_HOST_MULTIARCH)|" build-$$flavor/scalapack.pc > build-$$flavor/scalapack-$$flavor.pc ; \
	done

override_dh_install-arch:
	dh_install -a
	dh_missing --list-missing
	# test executables contain RUNPATH. Remove it.
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/x*
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/*tst
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/TIMING/*tim
	sed "s/$(DEB_HOST_MULTIARCH)/\$${CMAKE_LIBRARY_ARCHITECTURE}/g" \
          -i debian/libscalapack-*-dev/usr/lib/cmake/scalapack-*/scalapack-targets-none.cmake


# add --max-parallel=1 to force test in sequential mode
# MPICH testsuite disabled as some tests fail -- why???

# Note: openmpi tests routinely (but unreproducibly) fail on some buildds,
# so don't let test failure halt the build on these arches (but let the tests run)
ARCH_TEST_IGNORE_FAILURE=mips64el

# On some other arches, openmpi3 tests never exit (don't even timeout),
# so skip their tests altogether until a workaround or fix is known.
ARCH_NO_OPENMPI_TEST_LIST=armel armhf i386 mipsel powerpc

# The hppa build does complete, but takes a full day to timeout on half the openmpi3 tests.
# That's too long, so add it to the no-test list
ARCH_NO_OPENMPI_TEST_LIST += hppa

override_dh_auto_test-arch:
	for flavor in openmpi mpich; do \
	  echo "Running tests for libscalapack-$$flavor" ; \
	  echo '************************************************'; \
	  echo "****** TESTING $$flavor BUILD"; \
	  echo '************************************************'; \
	  for testDir in PBLAS/TESTING PBLAS/TIMING TESTING; do \
	    testfile=build-$$flavor/$${testDir}/CTestTestfile.cmake; \
	    if ! grep -q separate_arguments.*ENV.*MPIEXEC_PREFLAGS $$testfile ; then \
	      sed '0,/add_test/ s/add_test/separate_arguments(MPIEXEC_PREFLAGS NATIVE_COMMAND $$ENV{MPIEXEC_PREFLAGS})\nadd_test/' -i $$testfile; \
	      sed 's/"$${MPIEXEC_PREFLAGS}"/$${MPIEXEC_PREFLAGS}/' -i $$testfile; \
	    fi; \
	  done; \
	  RUNTESTS=yes; \
	  if [ "$$flavor" = "openmpi" ]; then \
	    case " $(ARCH_NO_OPENMPI_TEST_LIST) " in \
	      *\ $(DEB_HOST_ARCH)\ *) RUNTESTS=no;; \
	    esac; \
	  fi; \
	  if [ "$$RUNTESTS" = "yes" ]; then \
	    ( MPIEXEC_PREFLAGS="--allow-run-as-root --oversubscribe" dh_auto_test --builddirectory=build-$$flavor 2>&1 | tee build-$$flavor/dh_auto_test.log ) || /bin/true; \
	  else \
	    echo Tests have been disabled on $(DEB_HOST_ARCH) | tee build-$$flavor/dh_auto_test.log; \
	  fi; \
	  echo '************************************************'; \
	  echo "****** TESTING OF $$flavor BUILD IS COMPLETE"; \
	  echo '************************************************'; \
	done
	# mpich has been found to Fail some tests but openmpi should not, so only check the openmpi test logs.
	# openmpi may Timeout on slower arches, so only register actual Fails (or SegFaults), assigning them return value 2
	# Test only on linux, since openmpi on other OS (kfreebsd, hurd) does not support fakeroot
	#
	# Tests are hardwired to 4 processors, so ignore failure if less than 4 are used.
	#
	if [ "$$DEB_BUILD_ARCH_OS" = "linux" ] && $$( grep -qE "Failed|SegFault" build-openmpi/dh_auto_test.log ); then \
	  if [ $(NUMJOBS) -lt 4 ]; then \
	    echo Tests are hardwired to 4 processes. Only $(NUMJOBS) processes were used for the build, so test failures will be ignored.; \
	  fi; \
	  echo "OpenMPI tests failed:"; \
	  grep -E "\(Failed\)|\(SEGFAULT\)" build-openmpi/dh_auto_test.log; \
	  if [ $(NUMJOBS) -ge 4 ]; then \
	    case " $(ARCH_TEST_IGNORE_FAILURE) " in \
	      *\ $(DEB_HOST_ARCH)\ *) echo Test failures ignored on $(DEB_HOST_ARCH);; \
	      *) return 2;; \
	    esac; \
	  fi; \
	fi
